<?php
/**
 * @file
 * image_effects_text_test.features.inc
 */

/**
 * Implements hook_image_default_styles().
 */
function image_effects_text_test_image_default_styles() {
  $styles = array();

  // Exported image style: text-rotate-test
  $styles['text-rotate-test'] = array(
    'name' => 'text-rotate-test',
    'effects' => array(
      32 => array(
        'label' => 'Échelle',
        'help' => 'La mise à l\'échelle maintiendra les proportions originales de l\'image. Si une seule dimension est précisée, l\'autre dimension sera calculée automatiquement.',
        'effect callback' => 'image_scale_effect',
        'dimensions callback' => 'image_scale_dimensions',
        'form callback' => 'image_scale_form',
        'summary theme' => 'image_scale_summary',
        'module' => 'image',
        'name' => 'image_scale',
        'data' => array(
          'width' => '800',
          'height' => '',
          'upscale' => 0,
        ),
        'weight' => '1',
      ),
      33 => array(
        'label' => 'Overlay (watermark)',
        'help' => 'Choose the file image you wish to use as an overlay, and position it in a layer on top of the canvas.',
        'effect callback' => 'canvasactions_file2canvas_image',
        'form callback' => 'canvasactions_file2canvas_form',
        'summary theme' => 'canvasactions_file2canvas_summary',
        'module' => 'imagecache_canvasactions',
        'name' => 'canvasactions_file2canvas',
        'data' => array(
          'xpos' => 0,
          'ypos' => 0,
          'alpha' => '100',
          'path' => 'grid800x600.png',
        ),
        'weight' => '2',
      ),
      34 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '100',
          'ypos' => '200',
          'halign' => 'left',
          'valign' => 'bottom',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '45',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '100,200 45 left,bottom',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '3',
      ),
      35 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '300',
          'ypos' => '200',
          'halign' => 'center',
          'valign' => 'center',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '45',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '300,200 45 center,center',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '4',
      ),
      37 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '500',
          'ypos' => '200',
          'halign' => 'right',
          'valign' => 'top',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '45',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '500,200 45 right,top',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '5',
      ),
      38 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '100',
          'ypos' => '500',
          'halign' => 'left',
          'valign' => 'bottom',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '-30',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '100,500 -30 left,bottom',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '7',
      ),
      39 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '300',
          'ypos' => '500',
          'halign' => 'center',
          'valign' => 'center',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '-30',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '300,500 -30 center,center',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '8',
      ),
      40 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '600',
          'ypos' => '400',
          'halign' => 'right',
          'valign' => 'top',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '-30',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '600,400 -30 right,top',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '9',
      ),
    ),
  );

  // Exported image style: text-test
  $styles['text-test'] = array(
    'name' => 'text-test',
    'effects' => array(
      23 => array(
        'label' => 'Overlay (watermark)',
        'help' => 'Choose the file image you wish to use as an overlay, and position it in a layer on top of the canvas.',
        'effect callback' => 'canvasactions_file2canvas_image',
        'form callback' => 'canvasactions_file2canvas_form',
        'summary theme' => 'canvasactions_file2canvas_summary',
        'module' => 'imagecache_canvasactions',
        'name' => 'canvasactions_file2canvas',
        'data' => array(
          'xpos' => 'left',
          'ypos' => 'top',
          'alpha' => '100',
          'path' => 'grid800x600.png',
        ),
        'weight' => '-10',
      ),
      22 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '100',
          'ypos' => '200',
          'halign' => 'left',
          'valign' => 'top',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '100,200 left,top',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '-8',
      ),
      24 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '300',
          'ypos' => '200',
          'halign' => 'left',
          'valign' => 'center',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '300,200 left,center',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '3',
      ),
      25 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '500',
          'ypos' => '200',
          'halign' => 'left',
          'valign' => 'bottom',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '500,200 left,bottom',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '4',
      ),
      26 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '100',
          'ypos' => '400',
          'halign' => 'center',
          'valign' => 'top',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '100,400 center,top',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '5',
      ),
      27 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '300',
          'ypos' => '400',
          'halign' => 'center',
          'valign' => 'center',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '300,400 center,center',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '6',
      ),
      28 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '500',
          'ypos' => '400',
          'halign' => 'center',
          'valign' => 'bottom',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '500,400 center, bottom',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '7',
      ),
      29 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '100',
          'ypos' => '500',
          'halign' => 'right',
          'valign' => 'top',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '100,500 right,top',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '8',
      ),
      30 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '300',
          'ypos' => '500',
          'halign' => 'right',
          'valign' => 'center',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '300,500 right,center',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '9',
      ),
      31 => array(
        'label' => 'Texte',
        'help' => 'Add static or dynamic (coded) text to an image.',
        'dimensions passthrough' => TRUE,
        'form callback' => 'image_effects_text_form',
        'effect callback' => 'image_effects_text_effect',
        'summary theme' => 'image_effects_text_summary',
        'module' => 'image_effects_text',
        'name' => 'image_effects_text',
        'data' => array(
          'size' => '18',
          'xpos' => '500',
          'ypos' => '500',
          'halign' => 'right',
          'valign' => 'bottom',
          'RGB' => array(
            'HEX' => '000000',
          ),
          'alpha' => '100',
          'angle' => '0',
          'fontfile' => 'lhandw.ttf',
          'text_source' => 'text',
          'text' => '500,500 right,bottom',
          'php' => 'return \'Hello World!\'',
        ),
        'weight' => '10',
      ),
    ),
  );

  return $styles;
}
