<?php
/**
 * @file
 * materio_administration.features.user_permission.inc
 */

/**
 * Implements hook_user_default_permissions().
 */
function materio_administration_user_default_permissions() {
  $permissions = array();

  // Exported permission: 'access administration menu'.
  $permissions['access administration menu'] = array(
    'name' => 'access administration menu',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'admin_menu',
  );

  // Exported permission: 'access workflow summary views'.
  $permissions['access workflow summary views'] = array(
    'name' => 'access workflow summary views',
    'roles' => array(
      'root' => 'root',
    ),
    'module' => 'workflow_views',
  );

  // Exported permission: 'administer workflow'.
  $permissions['administer workflow'] = array(
    'name' => 'administer workflow',
    'roles' => array(
      'root' => 'root',
    ),
    'module' => 'workflow_admin_ui',
  );

  // Exported permission: 'assign Adhérent role'.
  $permissions['assign Adhérent role'] = array(
    'name' => 'assign Adhérent role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign Contact opérationnel role'.
  $permissions['assign Contact opérationnel role'] = array(
    'name' => 'assign Contact opérationnel role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign Premium role'.
  $permissions['assign Premium role'] = array(
    'name' => 'assign Premium role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign Student role'.
  $permissions['assign Student role'] = array(
    'name' => 'assign Student role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign Unverified role'.
  $permissions['assign Unverified role'] = array(
    'name' => 'assign Unverified role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign Utilisateur Alpha Tester role'.
  $permissions['assign Utilisateur Alpha Tester role'] = array(
    'name' => 'assign Utilisateur Alpha Tester role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign Utilisateur role'.
  $permissions['assign Utilisateur role'] = array(
    'name' => 'assign Utilisateur role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign administrator role'.
  $permissions['assign administrator role'] = array(
    'name' => 'assign administrator role',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'assign all roles'.
  $permissions['assign all roles'] = array(
    'name' => 'assign all roles',
    'roles' => array(
      'root' => 'root',
    ),
    'module' => 'role_delegation',
  );

  // Exported permission: 'display drupal links'.
  $permissions['display drupal links'] = array(
    'name' => 'display drupal links',
    'roles' => array(
      'root' => 'root',
    ),
    'module' => 'admin_menu',
  );

  // Exported permission: 'flush caches'.
  $permissions['flush caches'] = array(
    'name' => 'flush caches',
    'roles' => array(
      'root' => 'root',
    ),
    'module' => 'admin_menu',
  );

  // Exported permission: 'participate in workflow'.
  $permissions['participate in workflow'] = array(
    'name' => 'participate in workflow',
    'roles' => array(
      'Adhérent' => 'Adhérent',
      'Contact opérationnel' => 'Contact opérationnel',
      'Premium' => 'Premium',
      'Student' => 'Student',
      'Unverified' => 'Unverified',
      'Utilisateur' => 'Utilisateur',
      'Utilisateur Alpha Tester' => 'Utilisateur Alpha Tester',
      'administrator' => 'administrator',
      'anonymous user' => 'anonymous user',
      'authenticated user' => 'authenticated user',
      'root' => 'root',
    ),
    'module' => 'workflow_admin_ui',
  );

  // Exported permission: 'schedule workflow transitions'.
  $permissions['schedule workflow transitions'] = array(
    'name' => 'schedule workflow transitions',
    'roles' => array(
      'root' => 'root',
    ),
    'module' => 'workflow',
  );

  // Exported permission: 'send newsletter'.
  $permissions['send newsletter'] = array(
    'name' => 'send newsletter',
    'roles' => array(
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'simplenews',
  );

  // Exported permission: 'show workflow state form'.
  $permissions['show workflow state form'] = array(
    'name' => 'show workflow state form',
    'roles' => array(),
    'module' => 'workflow',
  );

  // Exported permission: 'subscribe to newsletters'.
  $permissions['subscribe to newsletters'] = array(
    'name' => 'subscribe to newsletters',
    'roles' => array(
      'Adhérent' => 'Adhérent',
      'Contact opérationnel' => 'Contact opérationnel',
      'Premium' => 'Premium',
      'Student' => 'Student',
      'Utilisateur' => 'Utilisateur',
      'administrator' => 'administrator',
      'anonymous user' => 'anonymous user',
      'root' => 'root',
    ),
    'module' => 'simplenews',
  );

  // Exported permission: 'subscribe to simplenews category 6274'.
  $permissions['subscribe to simplenews category 6274'] = array(
    'name' => 'subscribe to simplenews category 6274',
    'roles' => array(
      'anonymous user' => 'anonymous user',
      'authenticated user' => 'authenticated user',
    ),
    'module' => 'materio_user',
  );

  // Exported permission: 'subscribe to simplenews category 6374'.
  $permissions['subscribe to simplenews category 6374'] = array(
    'name' => 'subscribe to simplenews category 6374',
    'roles' => array(
      'Adhérent' => 'Adhérent',
      'Utilisateur Alpha Tester' => 'Utilisateur Alpha Tester',
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'materio_user',
  );

  // Exported permission: 'subscribe to simplenews category 6585'.
  $permissions['subscribe to simplenews category 6585'] = array(
    'name' => 'subscribe to simplenews category 6585',
    'roles' => array(
      'Utilisateur Alpha Tester' => 'Utilisateur Alpha Tester',
      'administrator' => 'administrator',
      'root' => 'root',
    ),
    'module' => 'materio_user',
  );

  return $permissions;
}
