<?php
/**
 * @file
 * materio_publications.features.inc
 */

/**
 * Implements hook_ctools_plugin_api().
 */
function materio_publications_ctools_plugin_api($module = NULL, $api = NULL) {
  if ($module == "strongarm" && $api == "strongarm") {
    return array("version" => "1");
  }
}

/**
 * Implements hook_image_default_styles().
 */
function materio_publications_image_default_styles() {
  $styles = array();

  // Exported image style: publication-couv.
  $styles['publication-couv'] = array(
    'label' => 'publication-couv',
    'effects' => array(
      16 => array(
        'name' => 'image_scale',
        'data' => array(
          'width' => 480,
          'height' => 480,
          'upscale' => 1,
        ),
        'weight' => 1,
      ),
    ),
  );

  return $styles;
}

/**
 * Implements hook_node_info().
 */
function materio_publications_node_info() {
  $items = array(
    'publication' => array(
      'name' => t('Publication'),
      'base' => 'node_content',
      'description' => '',
      'has_title' => '1',
      'title_label' => t('Titre'),
      'help' => '',
    ),
  );
  drupal_alter('node_info', $items);
  return $items;
}

/**
 * Implements hook_workflow_default_workflows().
 */
function materio_publications_workflow_default_workflows() {
  $workflows = array();

  // Exported workflow: Publication
  $workflows['Publication'] = array(
    'name' => 'Publication',
    'tab_roles' => '',
    'options' => 'a:4:{s:16:"comment_log_node";i:0;s:15:"comment_log_tab";i:0;s:13:"name_as_title";i:0;s:12:"watchdog_log";i:1;}',
    'states' => array(
      0 => array(
        'state' => '(creation)',
        'weight' => -50,
        'sysid' => 1,
        'status' => 1,
        'name' => 'Publication',
      ),
      1 => array(
        'state' => 'Importé',
        'weight' => 0,
        'sysid' => 0,
        'status' => 1,
        'name' => 'Publication',
      ),
      2 => array(
        'state' => 'Édité',
        'weight' => 1,
        'sysid' => 0,
        'status' => 1,
        'name' => 'Publication',
      ),
      3 => array(
        'state' => 'Masqué',
        'weight' => 2,
        'sysid' => 0,
        'status' => 1,
        'name' => 'Publication',
      ),
      4 => array(
        'state' => 'Publié',
        'weight' => 3,
        'sysid' => 0,
        'status' => 1,
        'name' => 'Publication',
      ),
    ),
    'transitions' => array(
      0 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => '(creation)',
        'target_state' => 'Masqué',
      ),
      1 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => '(creation)',
        'target_state' => 'Publié',
      ),
      2 => array(
        'roles' => 'root',
        'state' => '(creation)',
        'target_state' => 'Importé',
      ),
      3 => array(
        'roles' => 'administrator,root',
        'state' => 'Importé',
        'target_state' => 'Édité',
      ),
      4 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Importé',
        'target_state' => 'Masqué',
      ),
      5 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Importé',
        'target_state' => 'Publié',
      ),
      6 => array(
        'roles' => 'root',
        'state' => 'Édité',
        'target_state' => 'Importé',
      ),
      7 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Édité',
        'target_state' => 'Masqué',
      ),
      8 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Édité',
        'target_state' => 'Publié',
      ),
      9 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Masqué',
        'target_state' => 'Publié',
      ),
      10 => array(
        'roles' => 'root',
        'state' => 'Masqué',
        'target_state' => 'Importé',
      ),
      11 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Masqué',
        'target_state' => 'Édité',
      ),
      12 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Publié',
        'target_state' => 'Masqué',
      ),
      13 => array(
        'roles' => 'root',
        'state' => 'Publié',
        'target_state' => 'Importé',
      ),
      14 => array(
        'roles' => 'workflow_features_author_name,administrator,root',
        'state' => 'Publié',
        'target_state' => 'Édité',
      ),
    ),
    'node_types' => array(
      0 => 'breve',
      1 => 'company',
      2 => 'didactique',
      3 => 'faq',
      4 => 'looping_embed_video',
      5 => 'materiau',
      6 => 'page',
      7 => 'publication',
      8 => 'simplenews',
    ),
  );

  return $workflows;
}
