<?php

/**
 * @file
 * Default theme implementation to format the simplenews newsletter body.
 *
 * Copy this file in your theme directory to create a custom themed body.
 * Rename it to override it. Available templates:
 *   simplenews-newsletter-body--[tid].tpl.php
 *   simplenews-newsletter-body--[view mode].tpl.php
 *   simplenews-newsletter-body--[tid]--[view mode].tpl.php
 * See README.txt for more details.
 *
 * Available variables:
 * - $build: Array as expected by render()
 * - $build['#node']: The $node object
 * - $title: Node title
 * - $language: Language code
 * - $view_mode: Active view mode
 * - $simplenews_theme: Contains the path to the configured mail theme.
 * - $simplenews_subscriber: The subscriber for which the newsletter is built.
 *   Note that depending on the used caching strategy, the generated body might
 *   be used for multiple subscribers. If you created personalized newsletters
 *   and can't use tokens for that, make sure to disable caching or write a
 *   custom caching strategy implemention.
 *
 * @see template_preprocess_simplenews_newsletter_body()
 */
?>
<?php
$node_url = url('node/'.$build['#node']->nid, array('absolute' => TRUE));
?>
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tbody>
    <tr>
      <td style="padding: 37px 0; background-color: #eeeeee;" align="center" bgcolor="#eeeeee">
        <!-- #nl_container -->
        <p style="text-align:center; margin:5px 0;"><a href="<?php print $node_url; ?>" style="font-size:9px; color:#444444;">Voir la version en ligne / View this email on the web</a>
        <table bgcolor="#ffffff" style="margin: 0; border: 1px solid #dddddd; color: #444444; font-family: arial; font-size: 12px; border-color: #dddddd; background-color: #ffffff;" width="600" border="0" cellspacing="0" cellpadding="0">
          <tbody>
            <tr>
              <td>
                <!-- node content -->
                <?php print render($build); ?>
                <table style="margin: 0 0 0 10px; border-collapse: collapse; color: #444444; font-family: arial; font-size: 12px; border-color: #dddddd; background-color: #ffffff;">
                  <tbody>
                    <tr>
                      <td style="vertical-align: top; padding: 5px 0;" width="580">
                        <table style="border-collapse: collapse; width: 565px; color: #444444; font-family: arial; font-size: 12px; border-color: #dddddd; background-color: #ffffff;" width="565" cellspacing="0" cellpadding="0">
                          <tbody>
                            <tr>
                              <td style="padding: 5px 0 5px 5px; line-height: normal;">
                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                  <tbody>
                                    <tr>
                                      <td>
                                        <table border="0" cellspacing="0" cellpadding="0" align="left">
                                          <tbody>
                                            <tr>
                                              <td>
                                                <table style="border-collapse: collapse; align: left;" cellspacing="0" cellpadding="0" align="left">
                                                  <tbody>
                                                    <tr>
                                                      <td style="padding: 2px; margin: 0; vertical-align: top;">
                                                        <a href="http://www.facebook.com/sharer.php?u=<?php print $node_url; ?>" target="_blank" style="display: block; border: none; text-decoration: none;">
                                                          <img src="http://materio.com/sites/default/files/ico_social_facebook.png" alt="Facebook" style="vertical-align: top; border: none;">
                                                        </a>
                                                      </td>
                                                      <td style="padding: 2px; margin: 0; vertical-align: top;">
                                                        <a href="http://twitter.com/share?url=<?php print $node_url; ?>" target="_blank" style="display: block; border: none; text-decoration: none;">
                                                          <img src="http://materio.com/sites/default/files/ico_social_twitter.png" alt="Twitter" style="vertical-align: top; border: none;">
                                                        </a>
                                                      </td>
                                                      <td style="padding: 2px; margin: 0; vertical-align: top;">
                                                        <a href="http://www.linkedin.com/shareArticle?url=<?php print $node_url; ?>" target="_blank" style="display: block; border: none; text-decoration: none;">
                                                          <img src="http://materio.com/sites/default/files/ico_social_linkedin.png" alt="Linkedin" style="vertical-align: top; border: none;">
                                                        </a>
                                                      </td>
                                                      <td style="padding: 2px; margin: 0; vertical-align: top;">
                                                        <a href="http://pinterest.com/hello0691/ze-daily-mat%C3%A9rio/" target="_blank" style="display: block; border: none; text-decoration: none;">
                                                          <img src="http://materio.com/sites/default/files/ico_social_pinterest.png" alt="Pinterest" style="vertical-align: top; border: none;">
                                                        </a>
                                                      </td>
                                                    </tr>
                                                  </tbody>
                                                </table>
                                              </td>
                                            </tr>
                                          </tbody>
                                        </table>
                                      </td>
                                    </tr>
                                  </tbody>
                                </table>
                              </td>
                            </tr>
                          </tbody>
                        </table>
                      </td>
                    </tr>
                  </tbody>
                </table>